using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net;
using System.Security.Cryptography;
using System.Text;
using Aop.Api.Util;
using Library;

namespace MySystem
{
    public class HaoDaHelper
    {
        public readonly static HaoDaHelper Instance = new HaoDaHelper();
        private HaoDaHelper()
        {
        }


        #region 盒易付

        //测试环境
        // string BoxRequestUrl = "https://openapi-test.iboxpay.com";
        // string BoxAppId = "AT7317781468267548672";
        // string BoxAppSecret = "OfWuHQdhQfnE8NaF4xdtgk4B9CYqnbri";
        // string BoxPublicKey = "";
        // string BrhCode = "001040";

        //生产环境
        string BoxRequestUrl = "https://openapi.iboxpay.com";
        string BoxAppId = "AP7175619323825451008";
        string BoxAppSecret = "hUfR53gdjyfiZTBR5bILanMqRD1dXD7y";
        string BoxPublicKey = "";
        string BrhCode = "030145";

        public string BoxServiceFee(string SnList, string ServiceFee)
        {
            function.WriteLog(DateTime.Now.ToString(), "设置盒易付机具服务费");
            function.WriteLog(SnList, "设置盒易付机具服务费");
            Dictionary<string, object> reqdic = new Dictionary<string, object>();
            string batchNo = DateTime.Now.ToString("yyyyMMddHHmmssfff") + function.get_Random(8);

            reqdic.Add("snList", SnList.Split(',').ToList());//终端列表
            if (ServiceFee != "0")
            {
                ServiceFee += "00";
            }
            reqdic.Add("depositGear", ServiceFee);//押金档位
            reqdic.Add("modelId", "MHN10916");//费率，固定0.6
            reqdic.Add("brhCode", BrhCode);//机构号
            reqdic.Add("batchNo", batchNo);//批次号
            string req = Newtonsoft.Json.JsonConvert.SerializeObject(reqdic);

            Dictionary<string, string> headdic = GetHeader(reqdic);
            string head = Newtonsoft.Json.JsonConvert.SerializeObject(headdic);
            function.WriteLog("请求头\n" + head, "设置盒易付机具服务费");
            function.WriteLog("请求参数\n" + req, "设置盒易付机具服务费");
            function.WriteLog("请求地址：" + BoxRequestUrl + "/inst/register/terms", "设置盒易付机具服务费");
            string result = PostWebRequest(BoxRequestUrl + "/inst/register/terms", req, headdic);
            function.WriteLog("返回\n" + result + "\n\n", "设置盒易付机具服务费");
            return result;
        }

        #region 上传图片接口
        /// <summary>
        /// 执行带文件上传的HTTP POST请求。
        /// </summary>
        /// <param name="url">请求地址</param>
        /// <param name="textParams">请求文本参数</param>
        /// <param name="fileParams">请求文件参数</param>
        /// <param name="charset">编码字符集</param>
        /// <returns>HTTP响应</returns>
        public string DoPost(string url, string token, IDictionary<string, string> textParams, IDictionary<string, FileItem> fileParams, string charset = "utf-8")
        {
            // 如果没有文件参数，则走普通POST请求
            if (fileParams == null || fileParams.Count == 0)
            {
                return "";
            }

            string boundary = DateTime.Now.Ticks.ToString("X"); // 随机分隔线

            HttpWebRequest req = GetWebRequest(url, "POST");
            req.Headers.Add("X-File-Token", token);
            req.ContentType = "multipart/form-data;charset=" + charset + ";boundary=" + boundary;

            Stream reqStream = req.GetRequestStream();
            byte[] itemBoundaryBytes = Encoding.GetEncoding(charset).GetBytes("\r\n--" + boundary + "\r\n");
            byte[] endBoundaryBytes = Encoding.GetEncoding(charset).GetBytes("\r\n--" + boundary + "--\r\n");

            // 组装文本请求参数
            string textTemplate = "Content-Disposition:form-data;name=\"{0}\"\r\nContent-Type:text/plain\r\n\r\n{1}";
            IEnumerator<KeyValuePair<string, string>> textEnum = textParams.GetEnumerator();
            while (textEnum.MoveNext())
            {
                string textEntry = string.Format(textTemplate, textEnum.Current.Key, textEnum.Current.Value);
                byte[] itemBytes = Encoding.GetEncoding(charset).GetBytes(textEntry);
                reqStream.Write(itemBoundaryBytes, 0, itemBoundaryBytes.Length);
                reqStream.Write(itemBytes, 0, itemBytes.Length);
            }

            // 组装文件请求参数
            string fileTemplate = "Content-Disposition:form-data;name=\"{0}\";filename=\"{1}\"\r\nContent-Type:{2}\r\n\r\n";
            IEnumerator<KeyValuePair<string, FileItem>> fileEnum = fileParams.GetEnumerator();
            while (fileEnum.MoveNext())
            {
                string key = fileEnum.Current.Key;
                FileItem fileItem = fileEnum.Current.Value;
                string fileEntry = string.Format(fileTemplate, key, fileItem.GetFileName(), fileItem.GetMimeType());
                byte[] itemBytes = Encoding.GetEncoding(charset).GetBytes(fileEntry);
                reqStream.Write(itemBoundaryBytes, 0, itemBoundaryBytes.Length);
                reqStream.Write(itemBytes, 0, itemBytes.Length);

                byte[] fileBytes = fileItem.GetContent();
                reqStream.Write(fileBytes, 0, fileBytes.Length);
            }

            reqStream.Write(endBoundaryBytes, 0, endBoundaryBytes.Length);
            reqStream.Close();

            HttpWebResponse rsp = (HttpWebResponse)req.GetResponse();
            Encoding encoding = Encoding.GetEncoding(rsp.CharacterSet);
            return GetResponseAsString(rsp, encoding);
        }

        public HttpWebRequest GetWebRequest(string url, string method)
        {
            HttpWebRequest req = (HttpWebRequest)WebRequest.Create(url);
            req.ServicePoint.Expect100Continue = false;
            req.Method = method;
            req.KeepAlive = true;
            req.Timeout = 100000;
            return req;
        }

        /// <summary>
        /// 把响应流转换为文本。
        /// </summary>
        /// <param name="rsp">响应流对象</param>
        /// <param name="encoding">编码方式</param>
        /// <returns>响应文本</returns>
        public string GetResponseAsString(HttpWebResponse rsp, Encoding encoding)
        {
            StringBuilder result = new StringBuilder();
            Stream stream = null;
            StreamReader reader = null;

            try
            {
                // 以字符流的方式读取HTTP响应
                stream = rsp.GetResponseStream();
                reader = new StreamReader(stream, encoding);

                // 按字符读取并写入字符串缓冲
                int ch = -1;
                while ((ch = reader.Read()) > -1)
                {
                    // 过滤结束符
                    char c = (char)ch;
                    if (c != '\0')
                    {
                        result.Append(c);
                    }
                }
            }
            finally
            {
                // 释放资源
                if (reader != null) reader.Close();
                if (stream != null) stream.Close();
                if (rsp != null) rsp.Close();
            }

            return result.ToString();
        }
        #endregion

        public Dictionary<string, string> GetHeader(Dictionary<string, object> reqdic)
        {
            Dictionary<string, string> headdic = new Dictionary<string, string>();
            string timestamp = DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss");
            headdic.Add("appid", BoxAppId);//开发者id
            headdic.Add("appsecret", BoxAppSecret);//开发者密码
            headdic.Add("X-Up-AppId", BoxAppId);
            headdic.Add("X-Timestamp", timestamp);
            headdic.Add("X-Sign-Type", "SHA-256");
            string req = Newtonsoft.Json.JsonConvert.SerializeObject(reqdic);
            headdic.Add("X-Sign", SHA256Sign(timestamp + BoxAppSecret + req));
            return headdic;
        }

        public string SHA256Sign(string toSignStr)
        {
            byte[] toSignByte = Encoding.UTF8.GetBytes(toSignStr);
            SHA256 sha256 = SHA256.Create();
            byte[] signByte = sha256.ComputeHash(toSignByte);
            string sign = Convert.ToBase64String(signByte);
            return sign;
        }

        public bool VerifySign(string toSignStr, string signStr, int BrandId = 0)
        {
            var BoxPublicKey = HaodaParam.BoxPublicKey;
            if (BrandId == 1) BoxPublicKey = HaodaUnionParam.BoxPublicKey;

            byte[] toSignByte = Encoding.Default.GetBytes(toSignStr);
            byte[] signByte = Convert.FromBase64String(signStr);
            var toKey = Convert.FromBase64String(BoxPublicKey);
            var rsaroot = RSA.Create();
            rsaroot.ImportSubjectPublicKeyInfo(toKey, out _);
            var publicKeyParameters = rsaroot.ExportParameters(false);
            using (var rsa = RSA.Create())
            {
                rsa.ImportParameters(publicKeyParameters);
                var sha256 = SHA256.Create();
                var hash = sha256.ComputeHash(toSignByte);
                return rsa.VerifyHash(hash, signByte, HashAlgorithmName.SHA256, RSASignaturePadding.Pkcs1);
            }
        }

        public string SignData(string toSignStr, int BrandId = 0)
        {
            var BoxPublicKey = HaodaParam.BoxPublicKey;
            if (BrandId == 1) BoxPublicKey = HaodaUnionParam.BoxPublicKey;

            byte[] toSignByte = Encoding.UTF8.GetBytes(toSignStr);
            var toKey = Convert.FromBase64String(BoxPublicKey);
            var rsaroot = RSA.Create();
            rsaroot.ImportSubjectPublicKeyInfo(toKey, out _);
            var publicKeyParameters = rsaroot.ExportParameters(false);
            using (var rsa = RSA.Create())
            {
                rsa.ImportParameters(publicKeyParameters);
                var sha256 = SHA256.Create();
                var hash = sha256.ComputeHash(toSignByte);
                byte[] endByte = rsa.SignData(toSignByte, HashAlgorithmName.SHA256, RSASignaturePadding.Pkcs1);
                return Convert.ToBase64String(endByte);
            }
        }

        private string PostWebRequest(string postUrl, string paramData, Dictionary<string, string> headers)
        {
            string ret = string.Empty;
            try
            {
                function.WriteLog(DateTime.Now.ToString(), "请求开店宝API日志");
                function.WriteLog(postUrl, "请求开店宝API日志");
                function.WriteLog(paramData, "请求开店宝API日志");
                byte[] postData = System.Text.Encoding.UTF8.GetBytes(paramData);
                // 设置提交的相关参数 
                System.Net.HttpWebRequest request = System.Net.WebRequest.Create(postUrl) as System.Net.HttpWebRequest;
                System.Text.Encoding myEncoding = System.Text.Encoding.UTF8;
                request.Method = "POST";
                request.KeepAlive = false;
                request.AllowAutoRedirect = true;
                request.ContentType = "application/json";
                foreach (string key in headers.Keys)
                {
                    request.Headers.Add(key, headers[key]);
                }
                request.UserAgent = "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1; .NET CLR 2.0.50727; .NET CLR  3.0.04506.648; .NET CLR 3.5.21022; .NET CLR 3.0.4506.2152; .NET CLR 3.5.30729)";

                request.ContentLength = postData.Length;

                // 提交请求数据 
                System.IO.Stream outputStream = request.GetRequestStream();
                outputStream.Write(postData, 0, postData.Length);
                outputStream.Close();
                System.Net.HttpWebResponse response;
                System.IO.Stream responseStream;
                System.IO.StreamReader reader;
                string srcString;
                response = request.GetResponse() as System.Net.HttpWebResponse;
                responseStream = response.GetResponseStream();
                reader = new System.IO.StreamReader(responseStream, System.Text.Encoding.UTF8);
                srcString = reader.ReadToEnd();
                ret = srcString;   //返回值赋值
                reader.Close();
                function.WriteLog(srcString, "请求开店宝API日志");
            }
            catch (System.Net.WebException ex)
            {
                System.Net.HttpWebResponse response = (System.Net.HttpWebResponse)ex.Response;
                System.IO.Stream myResponseStream = response.GetResponseStream();
                //获取响应内容
                System.IO.StreamReader myStreamReader = new System.IO.StreamReader(myResponseStream);
                ret = myStreamReader.ReadToEnd();
                myResponseStream.Close();
            }
            catch (Exception ex)
            {
                ret = "fail";
                function.WriteLog(DateTime.Now.ToString() + "\r\n" + ex.ToString(), "请求开店宝API异常");
            }
            return ret;
        }


        /// <summary>
        /// 微信公众号和小程序支付接口
        /// </summary>
        /// <param name="mchtNo">盒子的商户编号</param>
        /// <param name="storeNo">盒子的门店编码</param>
        /// <param name="outOrderNo">商户订单号</param>
        /// <param name="transAmount">交易金额，单位：分</param>
        /// <param name="callbackUrl">交易完成之后，商户接收交易结果通知的地址</param>
        /// <param name="subOpenId">用户子标识</param>
        /// <param name="confirmCode">支付确认码</param>
        /// <param name="subAppId">公众号或者小程序appId</param>
        /// <param name="subAppIdType">对应的类型，默认为公众号， SUBSCRIPTION: 公众号 MINI_PROGRAM: 小程序</param>
        /// <param name="ledgerModel">分账类型:1不分账 2分账,注意只有开通了分账才能传这个字段</param>
        /// <returns></returns>
        public string WeChatPay(string mchtNo, string storeNo, string outOrderNo, decimal transAmount, string callbackUrl, string subOpenId, string confirmCode, string subAppId, string subAppIdType, string ledgerModel, int BrandId = 0)
        {
            var BoxRequestUrl = HaodaParam.BoxRequestUrl;
            if (BrandId == 1) BoxRequestUrl = HaodaUnionParam.BoxRequestUrl;

            function.WriteLog(DateTime.Now.ToString(), "好哒微信公众号和小程序支付");
            Dictionary<string, object> reqdic = new Dictionary<string, object>();
            reqdic.Add("mchtNo", mchtNo); //盒子的商户编号
            reqdic.Add("storeNo", storeNo); //盒子的门店编码	
            reqdic.Add("outOrderNo", outOrderNo); //商户订单号
            int payAmount = (int)(transAmount * 100);
            reqdic.Add("transAmount", payAmount); //交易金额，单位：分
            reqdic.Add("callbackUrl", callbackUrl); //交易完成之后，商户接收交易结果通知的地址	
            reqdic.Add("subOpenId", subOpenId); //用户子标识
            reqdic.Add("confirmCode", confirmCode); //支付确认码，由4位纯数字组成，每次请求时随机生成	
            reqdic.Add("subAppId", subAppId); //公众号或者小程序appId	
            reqdic.Add("subAppIdType", subAppIdType); //subAppId 对应的类型，默认为公众号， SUBSCRIPTION: 公众号 MINI_PROGRAM: 小程序
            reqdic.Add("ledgerModel", ledgerModel); //分账类型:1不分账 2分账,注意只有开通了分账才能传这个字段

            string req = Newtonsoft.Json.JsonConvert.SerializeObject(reqdic);
            function.WriteLog(req, "好哒微信公众号和小程序支付");
            Dictionary<string, string> headdic = GetHeader(req);
            string head = Newtonsoft.Json.JsonConvert.SerializeObject(headdic);
            function.WriteLog("请求头\n" + head, "好哒微信公众号和小程序支付");
            function.WriteLog("请求参数\n" + req, "好哒微信公众号和小程序支付");
            function.WriteLog("请求地址：" + BoxRequestUrl + "/api/hzg/v2/unitedtrade/wechat_js_pay", "好哒微信公众号和小程序支付");
            string result = PostWebRequest(BoxRequestUrl + "/api/hzg/v2/unitedtrade/wechat_js_pay", req, headdic);
            function.WriteLog("返回\n" + result + "\n\n", "好哒微信公众号和小程序支付");

            return result;
        }

        /// <summary>
        /// 支付宝服务窗支付接口
        /// </summary>
        /// <param name="mchtNo">盒子的商户编号</param>
        /// <param name="storeNo">盒子的门店编码</param>
        /// <param name="outOrderNo">商户订单号</param>
        /// <param name="transAmount">交易金额，单位：分</param>
        /// <param name="callbackUrl">交易完成之后，商户接收交易结果通知的地址</param>
        /// <param name="subOpenId">支付宝用户标识</param>
        /// <param name="confirmCode">支付确认码，由4位纯数字组成，每次请求时随机生成</param>
        /// <param name="ledgerModel">分账类型:1不分账 2分账,注意只有开通了分账才能传这个字段</param>
        /// <returns></returns>
        public string Alipay(string mchtNo, string storeNo, string outOrderNo, decimal transAmount, string callbackUrl, string subOpenId, string confirmCode, string ledgerModel, int BrandId = 0)
        {
            var BoxRequestUrl = HaodaParam.BoxRequestUrl;
            if (BrandId == 1) BoxRequestUrl = HaodaUnionParam.BoxRequestUrl;

            function.WriteLog(DateTime.Now.ToString(), "好哒支付宝服务窗支付");
            Dictionary<string, object> reqdic = new Dictionary<string, object>();
            reqdic.Add("mchtNo", mchtNo); //盒子的商户编号
            reqdic.Add("storeNo", storeNo); //盒子的门店编码	
            reqdic.Add("outOrderNo", outOrderNo); //商户订单号
            int payAmount = (int)(transAmount * 100);
            reqdic.Add("transAmount", payAmount); //交易金额，单位：分	
            reqdic.Add("callbackUrl", callbackUrl); //交易完成之后，商户接收交易结果通知的地址
            reqdic.Add("subOpenId", subOpenId); //支付宝用户标识	
            reqdic.Add("confirmCode", confirmCode); //支付确认码，由4位纯数字组成，每次请求时随机生成
            reqdic.Add("ledgerModel", ledgerModel); //分账类型:1不分账 2分账,注意只有开通了分账才能传这个字段

            string req = Newtonsoft.Json.JsonConvert.SerializeObject(reqdic);
            function.WriteLog(req, "好哒支付宝服务窗支付");
            Dictionary<string, string> headdic = GetHeader(req);
            string head = Newtonsoft.Json.JsonConvert.SerializeObject(headdic);
            function.WriteLog("请求头\n" + head, "好哒支付宝服务窗支付");
            function.WriteLog("请求参数\n" + req, "好哒支付宝服务窗支付");
            function.WriteLog("请求地址：" + BoxRequestUrl + "/api/hzg/v2/unitedtrade/ali_js_pay", "好哒支付宝服务窗支付");
            string result = PostWebRequest(BoxRequestUrl + "/api/hzg/v2/unitedtrade/ali_js_pay", req, headdic);
            function.WriteLog("返回\n" + result + "\n\n", "好哒支付宝服务窗支付");

            return result;
        }

        /// <summary>
        /// 好哒到账记录查询
        /// </summary>
        /// <param name="mchtNo">商户号</param>
        /// <param name="startTime">查询开始时间（yyyy-MM-dd）</param>
        /// <param name="endTime">查询结束时间（yyyy-MM-dd），最大查询时间区间31天</param>
        /// <param name="tradeMchtNo">收单商户号（15位）</param>
        /// <param name="cardNo">结算卡号</param>
        /// <param name="settleStatus">出款状态（0：入账成功、1：入账失败、2：结算超时、3：入账受理成功、4：已提交结算请求）</param>
        /// <param name="page">当前页数，默认1</param>
        /// <param name="rows">每页大小，默认10，最大500</param>
        /// <returns></returns>
        public string CardInComeRecord(string mchtNo, string startTime, string endTime, string tradeMchtNo, string cardNo, string settleStatus, string page, string rows, int BrandId = 0)
        {
            var BoxRequestUrl = HaodaParam.BoxRequestUrl;
            if (BrandId == 1) BoxRequestUrl = HaodaUnionParam.BoxRequestUrl;

            function.WriteLog(DateTime.Now.ToString(), "好哒到账记录查询");
            Dictionary<string, object> reqdic = new Dictionary<string, object>();
            reqdic.Add("mchtNo", mchtNo); //商户号
            reqdic.Add("startTime", startTime); //查询开始时间（yyyy-MM-dd）
            reqdic.Add("endTime", endTime); //查询结束时间（yyyy-MM-dd），最大查询时间区间31天
            reqdic.Add("tradeMchtNo", tradeMchtNo); //收单商户号（15位）
            reqdic.Add("cardNo", cardNo); //结算卡号
            reqdic.Add("settleStatus", settleStatus); //出款状态（0：入账成功、1：入账失败、2：结算超时、3：入账受理成功、4：已提交结算请求）
            reqdic.Add("page", page); //当前页数，默认1
            reqdic.Add("rows", rows); //每页大小，默认10，最大500

            string req = Newtonsoft.Json.JsonConvert.SerializeObject(reqdic);
            function.WriteLog(req, "好哒到账记录查询");
            Dictionary<string, string> headdic = GetHeader(req);
            string head = Newtonsoft.Json.JsonConvert.SerializeObject(headdic);
            function.WriteLog("请求头\n" + head, "好哒到账记录查询");
            function.WriteLog("请求参数\n" + req, "好哒到账记录查询");
            function.WriteLog("请求地址：" + BoxRequestUrl + "/api/v3/hzg/accb/to_account/query", "好哒到账记录查询");
            string result = PostWebRequest(BoxRequestUrl + "/api/v3/hzg/accb/to_account/query", req, headdic);
            function.WriteLog("返回\n" + result + "\n\n", "好哒到账记录查询");

            return result;
        }

        /// <summary>
        /// 好哒到账记录详情
        /// </summary>
        /// <param name="mchtNo">商户号</param>
        /// <param name="id">id</param>
        /// <returns></returns>
        public string CardInComeDetail(string mchtNo, string id, int BrandId = 0)
        {
            var BoxRequestUrl = HaodaParam.BoxRequestUrl;
            if (BrandId == 1) BoxRequestUrl = HaodaUnionParam.BoxRequestUrl;

            function.WriteLog(DateTime.Now.ToString(), "好哒到账记录详情");
            Dictionary<string, object> reqdic = new Dictionary<string, object>();
            reqdic.Add("mchtNo", mchtNo); //商户号
            reqdic.Add("id", id); //id

            string req = Newtonsoft.Json.JsonConvert.SerializeObject(reqdic);
            function.WriteLog(req, "好哒到账记录详情");
            Dictionary<string, string> headdic = GetHeader(req);
            string head = Newtonsoft.Json.JsonConvert.SerializeObject(headdic);
            function.WriteLog("请求头\n" + head, "好哒到账记录详情");
            function.WriteLog("请求参数\n" + req, "好哒到账记录详情");
            function.WriteLog("请求地址：" + BoxRequestUrl + "/api/v3/hzg/accb/to_account/get", "好哒到账记录详情");
            string result = PostWebRequest(BoxRequestUrl + "/api/v3/hzg/accb/to_account/get", req, headdic);
            function.WriteLog("返回\n" + result + "\n\n", "好哒到账记录详情");

            return result;
        }


        public Dictionary<string, string> GetHeader(string req, int BrandId = 0)
        {
            // var BoxAppSecret = HaodaParam.BoxAppSecret;
            // if (BrandId == 1) BoxAppSecret = HaodaUnionParam.BoxAppSecret;
            BoxAppSecret = HaodaUnionParam.BoxAppSecret;

            Dictionary<string, string> headdic = new Dictionary<string, string>();
            string timestamp = DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss");
            // headdic.Add("appid", BoxAppId);//开发者id
            // headdic.Add("appsecret", BoxAppSecret);//开发者密码
            headdic.Add("X-Up-AppId", BoxAppId);
            headdic.Add("X-Timestamp", timestamp);
            headdic.Add("X-Sign-Type", "SHA-256");
            headdic.Add("X-Sign", SHA256Sign(timestamp + BoxAppSecret + req));
            return headdic;
        }

        #endregion


    }
}